#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/keysym.h>
#include <X11/Xlocale.h>

#define DEFAULT_FONT	"-misc-myeongjo-medium-r-normal--16-*-*-*-c-*-*"
#define W_WIDTH  	100
#define W_HEIGHT 	100

main(int argc, char *argv[])
{
  Display	*display;
  int		screen;
  XIM		xim;
  XIC		xic;
  XIMStyles	*xim_styles;
  int		ii;
  Window	window, window2;
  XFontSet	fs;
  char		**missing_list;
  int		missing_count;
  char		*def_string;
  XRectangle	spot, s_rect, *st_area= NULL;
  XVaNestedList	preedit_attr, status_attr;
  XEvent	event;
  unsigned long mask, fevent;
  
  display = XOpenDisplay("");
  screen = DefaultScreen(display);
  
  if (setlocale(LC_CTYPE, "") == NULL) {
    fprintf(stderr, "Error : setlocale() !\n");
    exit(0);
  }

  if (! XSupportsLocale() ) {
    fprintf(stderr, "Error : XSupportsLocale() !\n");
    exit(0);
  }

  if( (fs = XCreateFontSet(display, DEFAULT_FONT, &missing_list,
		      &missing_count, &def_string)) == NULL) {
    fprintf(stderr, "Error : XCreateFontSet() !\n");
    exit(0);
  }

  if( (xim = XOpenIM(display, NULL, NULL, NULL)) == NULL )
  {
    printf("Error : XOpenIM !\n");
    exit(0);
  }
  
  window = XCreateSimpleWindow(display, RootWindow(display, screen),
			       0, 0, W_WIDTH, W_HEIGHT, 2,
			       BlackPixel(display, screen),
			       WhitePixel(display, screen));

  spot.x = 50;
  spot.y = 60;
  preedit_attr = XVaCreateNestedList(0,
				     XNSpotLocation, & spot,
				     XNFontSet, fs,
				     NULL);
  s_rect.x = 0;
  s_rect.y = 70;
  s_rect.width = W_WIDTH;
  s_rect.height = 20;
  status_attr = XVaCreateNestedList(0,
				    XNArea, & s_rect,
				    XNFontSet, fs,
				    NULL);

  xic = XCreateIC(xim,
		 XNInputStyle, XIMPreeditPosition | XIMStatusArea,
		 XNClientWindow, window,
		 XNPreeditAttributes, preedit_attr,
		 XNStatusAttributes, status_attr,
		 NULL);
  if( xic == NULL ) {
    printf("Error : XCreateIC() ! \n");
    XCloseIM(xim);
    exit(0);
  }
  XFree(preedit_attr);
  XFree(status_attr);

  status_attr = XVaCreateNestedList(0,
				    XNAreaNeeded, &st_area,
				    NULL);
  XGetICValues(xic, 
	       //               XNClientWindow, &window2,
               XNStatusAttributes, status_attr,
	       NULL);
  //  printf("Window = %x, Win2 = %x\n", window, window2);
  printf("Status Area : %d %d\n", st_area->width, st_area->height);

  XMapRaised(display, window);
  
  for(;;)
    XNextEvent(display, &event);

  XCloseIM(xim);
  XCloseDisplay(display);
  exit(0);
}
