#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/keysym.h>
#include <X11/Xlocale.h>

main(int argc, char *argv[])
{
  Display	*display;
  XIM		xim;
  XIMStyles	*xim_styles;
  int		ii;
  
  display = XOpenDisplay("");
  
  if (setlocale(LC_CTYPE, "") == NULL) {
    fprintf(stderr, "Error : setlocale() !\n");
    exit(0);
  }

  if (! XSupportsLocale() ) {
    fprintf(stderr, "Error : XSupportsLocale() !\n");
    exit(0);
  }

  if( (xim = XOpenIM(display, NULL, NULL, NULL)) == NULL )
  {
    printf("Error : XOpenIM !\n");
    exit(0);
  }
  
  if (XGetIMValues(xim, XNQueryInputStyle, &xim_styles, NULL) ||
      xim_styles == NULL)
  {
    printf("Input method doesn't support any style\n");
    XCloseIM(xim);
    exit(0);
  }
  for( ii = 0; ii < xim_styles->count_styles; ii++) {
    printf("(%d) %X %s", ii,
	     xim_styles->supported_styles[ii],
	     (xim_styles->supported_styles[ii] & XIMStatusNothing)
	     ? "XIMStatusNothing" : "");
    printf("%s",
	     (xim_styles->supported_styles[ii] & XIMStatusArea)
	     ? "XIMStatusArea" : "");
    printf("%s",
	     (xim_styles->supported_styles[ii] & XIMStatusCallbacks)
	     ? "XIMStatusCallbacks" : "");
    printf("%s",
	     (xim_styles->supported_styles[ii] & XIMStatusNone)
	     ? "XIMStatusNone" : "");
    printf(" | ");
    printf("%s",
	     (xim_styles->supported_styles[ii] & XIMPreeditNothing)
	     ? "XIMPreeditNothing" : "");
    printf("%s",
	     (xim_styles->supported_styles[ii] & XIMPreeditPosition)
	     ? "XIMPreeditPosition" : "");
    printf("%s",
	     (xim_styles->supported_styles[ii] & XIMPreeditCallbacks)
	     ? "XIMPreeditCallbacks" : "");
    printf("%s",
	     (xim_styles->supported_styles[ii] & XIMPreeditNone)
	     ? "XIMPreeditNone" : "");
    printf("%s",
	      (xim_styles->supported_styles[ii] & XIMPreeditArea)
	      ? "XIMPreeditArea" : "");

    printf("\n");
  }

  XCloseIM(xim);
  XCloseDisplay(display);
  exit(0);
}
